#ifndef _FOURTUN_H 
#define _FOURTUN_H 1

#define IPPROTO_IPV4 4

struct ipv6_tun_limit_hdr { 
	__u8 nexthdr;
	__u8 hdrlen;
	__u8 type; 
	__u8 len; 
	__u8 limit; 
	__u8 pad1; 
	__u8 pad2; 
}; 

struct fourtun_args { 
	__u8 version; 
	__u8 priority; 
	__u8 hoplimit; 
	__u8 encaplimit; 
	int  link; 
	struct in6_addr saddr;
	struct in6_addr daddr; 
};

/* ``fourtun private MIB'' */
struct fourtun_stat { 
	unsigned unmatched_packets;
	unsigned oom;
	unsigned frags_needed; 
	unsigned pmtu_sent;
	unsigned pmtu_rcv;
	unsigned pmtu_bad; 
	unsigned pmtu_rmt_sent; 
	unsigned pmtu_local_sent; 
	unsigned unmatched_icmp;
	unsigned bad_icmp;
	unsigned sent_icmp;
	unsigned v6_in_v4;
	unsigned bad_pkt; 
	unsigned tunnel_loop;
	unsigned mtu_change;
}; 

#include <asm/ioctl.h>

#define SIOCADD6TUNNEL (SIOCDEVPRIVATE + 10) 
#define SIOCDEL6TUNNEL (SIOCDEVPRIVATE + 11) 
#define SIOCCHG6TUNNEL (SIOCDEVPRIVATE + 12) 
#define SIOCGET6TUNNEL (SIOCDEVPRIVATE + 13) 
#define SIOCGTUNNEL6STAT (SIOCDEVPRIVATE + 14) 
/* to add more than +15 you need to fix net/core/dev.c */ 

#endif
